<?php
define('EPMOD25_VERSION', "2.1.0");
define('OC_VERSION', "2.0.1");

class ControllerSettingMenu extends Controller {
	private $error = array();

	public function index() {
		$this->validateMenu();

		$this->load->language('setting/menu');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/menu');

		$this->getList();
	}

	public function add() {
		$this->load->language('setting/menu');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/menu');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_setting_menu->addMenu($this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('setting/menu', 'token=' . $this->session->data['token'] . $url, true));
		}

		$this->getForm();
	}

	public function edit() {
		$this->load->language('setting/menu');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/menu');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_setting_menu->editMenu($this->request->get['menu_id'], $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('setting/menu', 'token=' . $this->session->data['token'] . $url, true));
		}

		$this->getForm();
	}

	public function delete() {
		$this->load->language('setting/menu');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/menu');

		if (isset($this->request->post['selected']) && $this->validateDelete()) {
			foreach ($this->request->post['selected'] as $menu_id) {
				$this->model_setting_menu->deleteMenu($menu_id);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('setting/menu', 'token=' . $this->session->data['token'] . $url, true));
		}

		$this->getList();
	}

	public function repair() {
		$this->load->language('setting/menu');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/menu');

		if ($this->validateRepair()) {
			$this->model_setting_menu->repairMenus();

			$this->session->data['success'] = $this->language->get('text_repair');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('setting/menu', 'token=' . $this->session->data['token'] . $url, true));
		}

		$this->getList();
	}

	public function copy() {
		$this->load->language('setting/menu');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/menu');

		if (isset($this->request->post['selected']) && $this->validateCopy()) {
			foreach ($this->request->post['selected'] as $menu_id) {
				$this->model_setting_menu->copyMenu($menu_id);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('setting/menu', 'token=' . $this->session->data['token'] . $url, true));
		}

		$this->getList();
	}

	protected function getList() {
		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'name';
		}

		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$limit = $this->config->get('config_limit_admin');

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text'  => $this->language->get('text_home'),
			'href'  => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text'  => $this->language->get('heading_title'),
			'href'  => $this->url->link('setting/menu', 'token=' . $this->session->data['token'] . $url, true)
		);

		$data['add'] = $this->url->link('setting/menu/add', 'token=' . $this->session->data['token'] . $url, true);
		$data['copy'] = $this->url->link('setting/menu/copy', 'token=' . $this->session->data['token'] . $url, true);
		$data['repair'] = $this->url->link('setting/menu/repair', 'token=' . $this->session->data['token'] . $url, true);
		$data['delete'] = $this->url->link('setting/menu/delete', 'token=' . $this->session->data['token'] . $url, true);

		$ajaxPermission = $this->user->hasPermission('modify', 'tool/ajax');

		if ($this->user->hasPermission('modify', 'setting/menu') && $ajaxPermission) {
			$data['ajaxPermission'] = true;
		} else{
			$data['ajaxPermission'] = false;
		}

		$data['menus'] = array();

		$filter_data = array(
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * $limit,
			'limit' => $limit
		);

		$menu_total = $this->model_setting_menu->getTotalMenus();

		$results = $this->model_setting_menu->getMenus($filter_data);

		foreach ($results as $result) {

			if ($result['position'] == 'board') {
				$parent = $this->language->get('text_board');
			} elseif (!$result['path']) {
				$parent = $this->language->get('text_parent');
			} else {
				$parent = $result['path'];
			}

			$data['menus'][] = array(
				'menu_id'     => $result['menu_id'],
				'name'        => $result['name'],
				'path'        => $parent,
				'status'      => $result['status'],
				'sort_order'  => $result['sort_order'],
				'edit'        => $this->url->link('setting/menu/edit', 'token=' . $this->session->data['token'] . '&menu_id=' . $result['menu_id'] . $url, true),
				'delete'      => $this->url->link('setting/menu/delete', 'token=' . $this->session->data['token'] . '&menu_id=' . $result['menu_id'] . $url, true)
			);
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_list'] = $this->language->get('text_list');
		$data['text_no_results'] = $this->language->get('text_no_results');
		$data['text_confirm'] = $this->language->get('text_confirm');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['column_name'] = $this->language->get('column_name');
		$data['column_parent'] = $this->language->get('column_parent');
		$data['column_status'] = $this->language->get('column_status');
		$data['column_sort_order'] = $this->language->get('column_sort_order');
		$data['column_action'] = $this->language->get('column_action');

		$data['button_add'] = $this->language->get('button_add');
		$data['button_copy'] = $this->language->get('button_copy');
		$data['button_rebuild'] = $this->language->get('button_rebuild');
		$data['button_delete'] = $this->language->get('button_delete');
		$data['button_edit'] = $this->language->get('button_edit');

		$data['tab_general'] = $this->language->get('tab_general');

		$data['token'] = $this->session->data['token'];

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array)$this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['sort_name'] = $this->url->link('setting/menu', 'token=' . $this->session->data['token'] . '&sort=name' . $url, true);
		$data['sort_path'] = $this->url->link('setting/menu', 'token=' . $this->session->data['token'] . '&sort=path' . $url, true);
		$data['sort_status'] = $this->url->link('setting/menu', 'token=' . $this->session->data['token'] . '&sort=status' . $url, true);

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		$pagination = new Pagination();
		$pagination->total = $menu_total;
		$pagination->page = $page;
		$pagination->limit = $limit;
		$pagination->url = $this->url->link('setting/menu', 'token=' . $this->session->data['token'] . $url . '&page={page}', true);

		$data['pagination'] = $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($pagination->total) ? (($page - 1) * $limit) + 1 : 0, ((($page - 1) * $limit) > ($pagination->total - $limit)) ? $pagination->total : ((($page - 1) * $limit) + $limit), $pagination->total, ceil($pagination->total / $limit));

		$data['sort'] = $sort;
		$data['order'] = $order;

		/* About Tab Begin */
		$data['text_extension_name'] = $this->language->get('text_extension_name');
		$data['extension_name'] = $this->language->get('entry_extension_name');

		$data['text_extension_version'] = $this->language->get('text_extension_version');
		$menu_version_check = $this->config->get('menu_control_version');

		if ($menu_version_check) {
			$data['extension_version'] = $menu_version_check;
		} else {
			$data['extension_version'] = EPMOD25_VERSION;
		}

		$data['text_extension_compat'] = $this->language->get('text_extension_compat');
		$data['extension_compat'] = sprintf($this->language->get('entry_extension_compat'), OC_VERSION);

		$data['text_extension_contact'] = $this->language->get('text_extension_contact');
		$data['extension_contact'] = '<a href="http://e-piksel.com/support">E-Piksel</a>';

		$data['text_extension_copyright'] = $this->language->get('text_extension_copyright');
		$data['extension_copyright'] = $this->language->get('entry_extension_copyright');

		$data['text_extension_defaults'] = $this->language->get('text_extension_defaults');
		$data['button_defaults'] = $this->language->get('button_defaults');
		$data['defaults'] = $this->url->link('setting/menu/defaults', 'token=' . $this->session->data['token'], true);

		$data['text_extension_uninstall'] = $this->language->get('text_extension_uninstall');
		$data['button_uninstall'] = $this->language->get('button_uninstall');
		$data['uninstall'] = $this->url->link('setting/menu/uninstall', 'token=' . $this->session->data['token'], true);

		$data['tab_about'] = $this->language->get('tab_about');
		/* About Tab End */

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('setting/menu_list', $data));
	}

	protected function getForm() {
		$data['lang'] = $this->language->get('code');

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_form'] = !isset($this->request->get['menu_id']) ? $this->language->get('text_add') : $this->language->get('text_edit');
		$data['text_none'] = $this->language->get('text_none');
		$data['text_default'] = $this->language->get('text_default');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_left'] = $this->language->get('text_left');
		$data['text_top'] = $this->language->get('text_top');
		$data['text_board'] = $this->language->get('text_board');

		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_description'] = $this->language->get('entry_description');
		$data['entry_parent'] = $this->language->get('entry_parent');
		$data['entry_link'] = $this->language->get('entry_link');
		$data['entry_user_group'] = $this->language->get('entry_user_group');
		$data['entry_icon'] = $this->language->get('entry_icon');
		$data['entry_position'] = $this->language->get('entry_position');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['entry_status'] = $this->language->get('entry_status');

		$data['help_user_group'] = $this->language->get('help_user_group');
		$data['help_icon'] = $this->language->get('help_icon');
		$data['help_position'] = $this->language->get('help_position');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		$data['tab_general'] = $this->language->get('tab_general');
		$data['tab_data'] = $this->language->get('tab_data');
		$data['tab_design'] = $this->language->get('tab_design');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = array();
		}

		$url = '';

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text'  => $this->language->get('text_home'),
			'href'  => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text'  => $this->language->get('heading_title'),
			'href'  => $this->url->link('setting/menu', 'token=' . $this->session->data['token'] . $url, true)
		);

		if (!isset($this->request->get['menu_id'])) {
			$data['action'] = $this->url->link('setting/menu/add', 'token=' . $this->session->data['token'] . $url, true);
		} else {
			$data['action'] = $this->url->link('setting/menu/edit', 'token=' . $this->session->data['token'] . '&menu_id=' . $this->request->get['menu_id'] . $url, true);
		}

		$data['cancel'] = $this->url->link('setting/menu', 'token=' . $this->session->data['token'] . $url, true);

		if (isset($this->request->get['menu_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$menu_info = $this->model_setting_menu->getMenu($this->request->get['menu_id']);
		}

		$data['token'] = $this->session->data['token'];

		$this->load->model('localisation/language');

		$data['languages'] = $this->model_localisation_language->getLanguages();

		if (isset($this->request->post['menu_description'])) {
			$data['menu_description'] = $this->request->post['menu_description'];
		} elseif (isset($this->request->get['menu_id'])) {
			$data['menu_description'] = $this->model_setting_menu->getMenuDescriptions($this->request->get['menu_id']);
		} else {
			$data['menu_description'] = array();
		}

		if (isset($this->request->post['path'])) {
			$data['path'] = $this->request->post['path'];
		} elseif (!empty($menu_info)) {
			$data['path'] = $menu_info['path'];
		} else {
			$data['path'] = '';
		}

		if (isset($this->request->post['parent_id'])) {
			$data['parent_id'] = $this->request->post['parent_id'];
		} elseif (!empty($menu_info)) {
			$data['parent_id'] = $menu_info['parent_id'];
		} else {
			$data['parent_id'] = 0;
		}

		$ignore = array(
			'common/column_left',
			'common/dashboard',
			'common/filemanager',
			'common/login',
			'common/logout',
			'common/forgotten',
			'common/reset',
			'common/footer',
			'common/header',
			'dashboard/activity',
			'dashboard/chart',
			'dashboard/member',
			'dashboard/map',
			'dashboard/online',
			'dashboard/order',
			'dashboard/recent',
			'dashboard/sale',
			'error/not_found',
			'error/permission'
		);

		$data['current_links'] = array();

		$files = glob(DIR_APPLICATION . 'controller/*/*.php');

		foreach ($files as $file) {
			$files_data = explode('/', dirname($file));

			$link = end($files_data) . '/' . basename($file, '.php');

			if (!in_array($link, $ignore)) {
				$data['current_links'][] = $link;
			}
		}

		if (isset($this->request->post['link'])) {
			$data['links'] = $this->request->post['link'];
		} elseif (!empty($menu_info['link'])) {
			$data['links'] = $menu_info['link'];
		} else {
			$data['links'] = array();
		}

		if (isset($this->request->post['addition'])) {
			$data['addition'] = $this->request->post['addition'];
		} elseif (!empty($menu_info)) {
			$data['addition'] = $menu_info['addition'];
		} else {
			$data['addition'] = '';
		}

		$this->load->model('user/user_group');
		$data['user_groups'] = $this->model_user_user_group->getUserGroups();

		if (isset($this->request->post['menu_user_group'])) {
			$data['menu_user_group'] = $this->request->post['menu_user_group'];
		} elseif (!empty($menu_info)) {
			$data['menu_user_group'] = $this->model_setting_menu->getMenuUserGroups($this->request->get['menu_id']);
		} else {
			$data['menu_user_group'] = array(1);
		}

		if (isset($this->request->post['icon'])) {
			$data['icon'] = $this->request->post['icon'];
		} elseif (!empty($menu_info)) {
			$data['icon'] = $menu_info['icon'];
		} else {
			$data['icon'] = '';
		}

		if (isset($this->request->post['position'])) {
			$data['position'] = $this->request->post['position'];
		} elseif (!empty($menu_info)) {
			$data['position'] = $menu_info['position'];
		} else {
			$data['position'] = '';
		}

		if (isset($this->request->post['sort_order'])) {
			$data['sort_order'] = $this->request->post['sort_order'];
		} elseif (!empty($menu_info)) {
			$data['sort_order'] = $menu_info['sort_order'];
		} else {
			$data['sort_order'] = 0;
		}

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($menu_info)) {
			$data['status'] = $menu_info['status'];
		} else {
			$data['status'] = 1;
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('setting/menu_form', $data));
	}

	protected function validateForm() {
		if (!$this->user->hasPermission('modify', 'setting/menu')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		foreach ($this->request->post['menu_description'] as $language_id => $value) {
			if ((utf8_strlen($value['name']) < 2) || (utf8_strlen($value['name']) > 255)) {
				$this->error['name'][$language_id] = $this->language->get('error_name');
			}
		}

		if ($this->error && !isset($this->error['warning'])) {
			$this->error['warning'] = $this->language->get('error_warning');
		}

		return !$this->error;
	}

	protected function validateDelete() {
		if (!$this->user->hasPermission('modify', 'setting/menu')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	protected function validateRepair() {
		if (!$this->user->hasPermission('modify', 'setting/menu')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	protected function validateCopy() {
		if (!$this->user->hasPermission('modify', 'setting/menu')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	protected function validateMenu() {
		if (!$this->user->hasPermission('modify', 'setting/menu')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		$this->load->model('setting/menu');

		$menu_version_check = $this->config->get('menu_control_version');

		/* Install Check */
		$db_check = $this->db->query("SHOW TABLES LIKE '" . DB_PREFIX . "emenu'");

		if (!$menu_version_check && !$db_check->num_rows) {
			$this->model_setting_menu->getInstall();

			$this->response->redirect($this->url->link('setting/menu', 'token=' . $this->session->data['token'], true));
		}

		/* Update Check */
		$column_exists = $this->db->query("SHOW COLUMNS FROM " . DB_PREFIX . "emenu LIKE 'icon'");

		if ($menu_version_check < EPMOD25_VERSION && !$column_exists->num_rows) {
			$this->model_setting_menu->getUpdate();

			$this->response->redirect($this->url->link('setting/menu', 'token=' . $this->session->data['token'], true));
		}

		return !$this->error;
	}

	public function uninstall() {
		if (!$this->user->hasPermission('modify', 'setting/menu')) {
			$this->response->redirect($this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true));
		} else {
			$db_check = $this->db->query("SHOW TABLES LIKE '" . DB_PREFIX . "emenu'");

			if ($db_check->num_rows) {
				$this->load->model('setting/menu');

				$this->model_setting_menu->getUninstall();
			}

			$this->response->redirect($this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true));
		}
	}

	public function defaults() {
		if (!$this->user->hasPermission('modify', 'setting/menu')) {
			$this->response->redirect($this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true));
		} else {
			$db_check = $this->db->query("SHOW TABLES LIKE '" . DB_PREFIX . "emenu'");

			if ($db_check->num_rows) {
				$this->load->model('setting/menu');

				$this->model_setting_menu->getUninstall();
				$this->model_setting_menu->getInstall();
			}

			$this->response->redirect($this->url->link('setting/menu', 'token=' . $this->session->data['token'], true));
		}
	}

	public function autocomplete() {
		$json = array();

		if (isset($this->request->get['filter_name'])) {
			$this->load->model('setting/menu');

			if (isset($this->request->get['filter_name'])) {
				$filter_name = $this->request->get['filter_name'];
			} else {
				$filter_name = '';
			}

			$filter_data = array(
				'filter_name' => $filter_name,
				'start'       => 0,
				'limit'       => 5
			);

			$results = $this->model_setting_menu->getMenus($filter_data);

			foreach ($results as $result) {
				$json[] = array(
					'menu_id' => $result['menu_id'],
					'name'    => strip_tags(html_entity_decode($result['name'], ENT_QUOTES, 'UTF-8'))
				);
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function ajax() {
		$json = array();

		$ajaxPermission = $this->user->hasPermission('modify', 'tool/ajax');

		if ($this->user->hasPermission('modify', 'setting/menu') && $ajaxPermission) {

			$this->load->model('setting/menu');

			if (isset($this->request->post['menu_id']) && isset($this->request->post['status'])) {
				$this->model_setting_menu->ajaxMenuStatus($this->request->post['menu_id'], $this->request->post['status']);
				$json['success'] = 1;
				$json['status'] = ($this->request->post['status']) ? true : false;
			}

			if (isset($this->request->post['menu_id']) && isset($this->request->post['sort_order'])) {
				if (preg_match('/^[0-9]+$/', $this->request->post['sort_order'])) {
					$this->model_setting_menu->ajaxMenuOrder($this->request->post['menu_id'], $this->request->post['sort_order']);
					$json['success'] = 1;
				} else {
					$json['error'] = 1;
				}
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
}