<?php
class ControllerToolsalesagentclist extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('tool/salesagentclist');

		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('tool/salesagent');
		$this->model_tool_salesagent->createTable();

		$this->getList();
	}

	public function add() {
		$this->load->language('tool/salesagentclist');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('tool/salesagent');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {

			$this->model_tool_salesagent->addclist($this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('tool/salesagentclist', 'token=' . $this->session->data['token'] . $url, 'SSL'));
		}

		$this->getForm();
	}

	public function edit() {
		$this->load->language('tool/salesagentclist');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('tool/salesagent');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {
			$this->model_tool_salesagent->editclist($this->request->get['clist_id'], $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('tool/salesagentclist', 'token=' . $this->session->data['token'] . $url, 'SSL'));
		}

		$this->getForm();
	}

	public function delete() {
		$this->load->language('tool/salesagentclist');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('tool/salesagent');

		if (isset($this->request->post['selected']) && $this->validateDelete()) {
			foreach ($this->request->post['selected'] as $clist_id) {
				$this->model_tool_salesagent->deleteclist($clist_id);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$url = '';

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			$this->response->redirect($this->url->link('tool/salesagentclist', 'token=' . $this->session->data['token'] . $url, 'SSL'));
		}

		$this->getList();
	}

	protected function getList() {


		if (isset($this->request->get['filter_name'])) {
			$filter_name = $this->request->get['filter_name'];
		} else {
			$filter_name = null;
		}

		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'c.name';
		}

		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'ASC';
		}

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$url = '';

		if (isset($this->request->get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('tool/salesagentclist', 'token=' . $this->session->data['token'] . $url, 'SSL')
		);

		$data['add'] = $this->url->link('tool/salesagentclist/add', 'token=' . $this->session->data['token'] . $url, 'SSL');
		$data['delete'] = $this->url->link('tool/salesagentclist/delete', 'token=' . $this->session->data['token'] . $url, 'SSL');
		$data['back'] = $this->url->link('tool/salesagent', 'token=' . $this->session->data['token'] . $url, 'SSL');

		$data['salesagentclists'] = array();

		$filter_data = array(
			'filter_name'	  => $filter_name,
			'sort'  => $sort,
			'order' => $order,
			'start' => ($page - 1) * $this->config->get('config_limit_admin'),
			'limit' => $this->config->get('config_limit_admin')
		);

		$salesagentclist_total = $this->model_tool_salesagent->getTotalClist($filter_data);
		$results = $this->model_tool_salesagent->getclists($filter_data);

		foreach ($results as $result) {
			$data['salesagentclists'][] = array(
				'clist_id' => $result['clist_id'],
				'name'          => $result['name'],
				'edit'           => $this->url->link('tool/salesagentclist/edit', 'token=' . $this->session->data['token'] . '&clist_id=' . $result['clist_id'] . $url, 'SSL')
			);
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_list'] = $this->language->get('text_list');
		$data['text_no_results'] = $this->language->get('text_no_results');
		$data['text_confirm'] = $this->language->get('text_confirm');

		$data['column_action'] = $this->language->get('column_action');
		$data['column_name'] = $this->language->get('column_name');

		$data['text_filter_name'] = $this->language->get('text_filter_name');
		$data['filter_name'] = $this->language->get('filter_name');

		$data['text_add'] = $this->language->get('text_add');
		$data['button_edit'] = $this->language->get('button_edit');
		$data['button_delete'] = $this->language->get('button_delete');
		$data['button_filter'] = $this->language->get('button_filter');
		$data['button_back'] = $this->language->get('button_back');
		$data['text_howitworks'] = $this->language->get('text_howitworks');
		$data['text_howitworks_content'] = $this->language->get('text_howitworks_content');

		$data['token'] = $this->session->data['token'];

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array)$this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if (isset($this->request->get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['sort_name'] = $this->url->link('tool/salesagentclist', 'token=' . $this->session->data['token'] . '&sort=c.name' . $url, 'SSL');

		$url = '';

		if (isset($this->request->get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		$pagination = new Pagination();
		$pagination->total = $salesagentclist_total;
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->url = $this->url->link('tool/salesagentclist', 'token=' . $this->session->data['token'] . $url . '&page={page}', 'SSL');

		$data['pagination'] = $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($salesagentclist_total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($salesagentclist_total - $this->config->get('config_limit_admin'))) ? $salesagentclist_total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $salesagentclist_total, ceil($salesagentclist_total / $this->config->get('config_limit_admin')));

		$data['sort'] = $sort;
		$data['order'] = $order;
		$data['filter_name'] = $filter_name;

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('tool/salesagentclist_list.tpl', $data));
	}

	protected function getForm() {
		
		$data['heading_title'] = $this->language->get('heading_title');
		$data['version'] = str_replace(".","",VERSION);
		$data['text_form'] = !isset($this->request->get['clist_id']) ? $this->language->get('text_add') : $this->language->get('text_edit');

		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_products'] = $this->language->get('entry_products');
		$data['entry_categories'] = $this->language->get('entry_categories');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$url = '';

		if (isset($this->request->get['filter_name'])) {
			$url .= '&filter_name=' . urlencode(html_entity_decode($this->request->get['filter_name'], ENT_QUOTES, 'UTF-8'));
		}

		if (isset($this->request->get['sort'])) {
			$url .= '&sort=' . $this->request->get['sort'];
		}

		if (isset($this->request->get['order'])) {
			$url .= '&order=' . $this->request->get['order'];
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('tool/salesagentclist', 'token=' . $this->session->data['token'] . $url, 'SSL')
		);

		if (!isset($this->request->get['clist_id'])) {
			$data['action'] = $this->url->link('tool/salesagentclist/add', 'token=' . $this->session->data['token'] . $url, 'SSL');
		} else {
			$data['action'] = $this->url->link('tool/salesagentclist/edit', 'token=' . $this->session->data['token'] . '&clist_id=' . $this->request->get['clist_id'] . $url, 'SSL');
		}

		$data['cancel'] = $this->url->link('tool/salesagentclist', 'token=' . $this->session->data['token'] . $url, 'SSL');

		if (isset($this->request->get['clist_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$salesagentclist_info = $this->model_tool_salesagent->getclist($this->request->get['clist_id']);
		}

		if (isset($this->request->get['clist_id'])) {
			$data['clist_id'] = $this->request->get['clist_id'];
		} else {
			$data['clist_id'] =  0;
		}

		$data['token'] = $this->session->data['token'];

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($salesagentclist_info)) {
			$data['name'] = $salesagentclist_info['name'];
		} else {
			$data['name'] = "";
		}

		if (isset($this->request->post['products'])) {
	      $products = $this->request->post['products'];
	    } elseif (!empty($salesagentclist_info)) {
	      $products = json_decode($salesagentclist_info['product_id'],true);
	    } else {
	      $products = array();
	    }
	    $this->load->model("catalog/product");
	    $data['products'] = array();
	    foreach ($products as $key => $value) {
	        $product_info = $this->model_catalog_product->getProduct($value);

	        if ($product_info) {
	          $data['products'][] = array(
	            'product_id' => $product_info['product_id'],
	            'name'       => $product_info['name']
	          );
	        }
	    }

	    if (isset($this->request->post['categories'])) {
	      $categories = $this->request->post['categories'];
	    } elseif (!empty($salesagentclist_info)) {
	      $categories = json_decode($salesagentclist_info['category_id'],true);
	    } else {
	      $categories = array();
	    }

	    $this->load->model("catalog/category");
	    $data['categories'] = array();
	    foreach ($categories as $key => $value) {
	        $category_info = $this->model_catalog_category->getCategory($value);

	        if ($category_info) {
	          $data['categories'][] = array(
	            'category_id' => $category_info['category_id'],
	            'name' => ($category_info['path']) ? $category_info['path'] . ' &gt; ' . $category_info['name'] : $category_info['name']
	          );
	        }
	    }

		$data['token'] = $this->session->data['token'];
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('tool/salesagentclist_form.tpl', $data));
	}

	protected function validateForm() {
		
		if (!$this->user->hasPermission('modify', 'tool/salesagentclist')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 255)) {
			$this->error['warning'] = $this->language->get('error_name');
		}

		if ((!isset($this->request->post['products'])) && (!isset($this->request->post['categories']))) {
			$this->error['warning'] = $this->language->get('error_catalog');
		}

		return !$this->error;
	}

	protected function validateDelete() {
		if (!$this->user->hasPermission('modify', 'tool/salesagentclist')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	public function autocomplete() {
		$json = array();

		if (isset($this->request->get['filter_name'])) {
			$this->load->model('tool/salesagent');

			$filter_data = array(
				'filter_name' => $this->request->get['filter_name'],
				'start'       => 0,
				'limit'       => 5
			);

			$results = $this->model_tool_salesagent->getclists($filter_data);

			foreach ($results as $result) {
				$json[] = array(
					'clist_id' => $result['clist_id'],
					'name'            => strip_tags(html_entity_decode($result['name'], ENT_QUOTES, 'UTF-8'))
				);
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
}