<?php   
class ModelStockalertStockalert extends Model {    
        private $eventTrigger = '';
        private $doLog = true;
        private $log = '';
        
        public function getInstance($data){
                if(isset($data['eventTrigger'])){
                    $this->eventTrigger = $data['eventTrigger'];
                }
                
                if($this->config->get('stockalert_log')){
                    $this->doLog = true;
                }
                
                if($this->doLog) $this->log = new Log('stockalert-'.$this->eventTrigger.'.log');
                
                return $this;
        }

        public function trackLog($data){
            if($this->doLog){
                $message = print_r($data, true);
                $this->log->write($message);
            }
        }
        public function checkProductStocks($productIds='',$sendmail=1,$data=array()){
            $this->trackLog('ProductsIds: ');
            $this->trackLog($productIds);
            $getAll = isset($data['getall'])?$data['getall']:0;
            
            ## if productIds not empty than check for those productIds else check for all active products.
            if($productIds != '' && !is_array($productIds)) $productIds = array($productIds);
            $columns = "quantity, model,sku,image,name,quantityalert,subtract";
            
            if(!empty($productIds) && is_array($productIds)){
                $productIdstr = implode(",",$productIds);
                $sql = "SELECT ".DB_PREFIX."product.product_id, $columns FROM " . DB_PREFIX . "product join ".DB_PREFIX."product_description on ".DB_PREFIX."product.product_id=".DB_PREFIX."product_description.product_id WHERE status=1 AND product_id in ('" . $productIdstr. "')";
            }else{
                $sql = "SELECT ".DB_PREFIX."product.product_id, $columns FROM " . DB_PREFIX . "product join ".DB_PREFIX."product_description on ".DB_PREFIX."product.product_id=".DB_PREFIX."product_description.product_id WHERE status=1 ";
            }
            
            if (!empty($data['filter_name'])) {
                $sql .= " AND lower(name) LIKE '%" . strtolower($this->db->escape($data['filter_name'])) . "%'";
            }
            if (!empty($data['filter_model'])) {
                $sql .= " AND lower(model) LIKE '%" . strtolower($this->db->escape($data['filter_model'])) . "%'";
            }
            
            $this->trackLog('SQL: '.$sql);
            $products = $this->db->query($sql);
            if($products->num_rows < 1){
                $this->trackLog('No Products found');
                return;
            }
            $lowProductsArray = array();
            $default_alert_count = $this->config->get('stockalert_inventory_count')?$this->config->get('stockalert_inventory_count'):0;

            foreach($products->rows as $product){
                $product_id = $product['product_id'];
                $this->trackLog('======================================');
                $this->trackLog($product_id);
				$alert_count = $default_alert_count;
                if($this->config->get('stockalert_product_based_alert') === 'Y' && $product['quantityalert'] ){     
                    $alert_count = $product['quantityalert'];
                }                
                $this->trackLog('-->Stock Compare: Stock ='.$product['quantity'].' alert= '.$alert_count);
                //if ($product['subtract'] == 1 && $product['quantity'] <	$alert_count) {
                if ($product['quantity'] <= $alert_count || $getAll) {
                    $lowInventory_product['product_id'] = $product['product_id'];
                    $lowInventory_product['name'] = $product['name'];
                    $lowInventory_product['model'] = $product['model']; 
                    $lowInventory_product['sku'] = $product['sku']; 
                    $lowInventory_product['quantity'] = $product['quantity'];
                    $lowInventory_product['image'] = $product['image'];
                    $lowInventory_product['quantityalert'] = $alert_count;
                    $lowProductsArray[$product_id]['details'] = $lowInventory_product;
                    $this->trackLog('-->Product alert: 1');
                }
                
                {
                    ## This is normal proudct with or without options.
                    $this->trackLog('-->Normal Alert: 1');
                    $where = " 1 ";
                    if(!$getAll) $where = " quantity <= ".(int)$alert_count." ";
                    $pOptions = $this->db->query("SELECT pov.*,ovd.name as option_value_name,od.name as option_name FROM " . DB_PREFIX . "product_option_value pov left join " . DB_PREFIX . "option_value_description ovd on pov.option_value_id=ovd.option_value_id LEFT JOIN " . DB_PREFIX . "option_description od ON pov.option_id = od.option_id WHERE product_id = '" . (int)$product_id . "' AND ".$where);
                    if($pOptions->num_rows > 0){
                        $this->trackLog($pOptions);
                        foreach($pOptions->rows as $option){
                            if(!isset($lowProductsArray[$product['product_id']]['details'])){
                                $lowInventory_product['product_id'] = $product['product_id'];
                                $lowInventory_product['name'] = $product['name'];
                                $lowInventory_product['model'] = $product['model']; 
                                $lowInventory_product['sku'] = $product['sku']; 
                                $lowInventory_product['quantity'] = $product['quantity'];
                                $lowInventory_product['image'] = $product['image'];
                                $lowInventory_product['quantityalert'] = $alert_count;
                                $lowProductsArray[$product['product_id']]['details'] = $lowInventory_product;
                            }
                            $lowInventory_productoption = array();
                            $lowInventory_productoption['name'] = $option['option_name'];
                            $lowInventory_productoption['value'] = $option['option_value_name'];
                            $lowInventory_productoption['quantity'] = $option['quantity'];
                            $lowProductsArray[$product['product_id']]['options'][] = $lowInventory_productoption;
                            $lowProductsArray[$product['product_id']]['optionsArray'][$lowInventory_productoption['name'] ][] = $lowInventory_productoption;
                        }
                    }
                }
                $this->trackLog('======================================');
            }
            if(!empty($lowProductsArray) && $sendmail){
                $this->sendAlert($lowProductsArray,'Feed Updates');
            }else{
                return $lowProductsArray;
            }
        }
        
        public function sendAlert($lowProductsArray,$type){
            $this->trackLog('sending alert: '.$type);
            $this->trackLog($lowProductsArray);
            $this->load->model('setting/store');
            $this->load->language('mail/customer');
            $mail = new Mail($this->config->get('config_mail'));
            //$mail->protocol = $this->config->get('config_mail_protocol');
            //$mail->parameter = $this->config->get('config_mail_parameter');
            //$mail->hostname = $this->config->get('config_smtp_host');
            //$mail->username = $this->config->get('config_smtp_username');
            //$mail->password = $this->config->get('config_smtp_password');
            //$mail->port = $this->config->get('config_smtp_port');
            //$mail->timeout = $this->config->get('config_smtp_timeout');
            $mail->setFrom($this->config->get('config_email'));
            $emails = $this->config->get('stockalert_inventory_emails');
            $emails = str_replace(' ','',$emails);
            if(!$emails || $emails == ''){ $emails = $this->config->get('config_email');}
            //$mail->setTo($emails);
            $mail->setSender('Stock Alert');
            $mail->setSubject('Stock Alert - '.$type);
            $adminLink = $this->url->link('module/stockalert/lowstockproducts', '', 'SSL');
            $message = "<div style='border:solid 1px #8EAEC3;font-size15px;padding:7px;'>Hi ".$this->config->get('config_owner').", <br><br> The following items could be out of stock soon based on <strong>$type</strong> and Now would be a good time to restock your inventory, so you can continue to sell these items without interruption..<br>
                Kindly <a href='".$adminLink."'>view your low-stock items</a> and revise inventory.<br><br>";
            $message .= "<table colspan=5 cellpadding=5 style='border-collapse: collapse;width: 100%;border: 1px solid #010101;border-left: 1px solid #010101;margin-bottom: 20px;'>
            <thead style='display: table-header-group;vertical-align: middle;border: 1px solid #010101;background:#EE6A50;'><tr style='display: table-row;'>
                <td width='5%'> Sr.no</td>
                <td width='40%'> Product Name</td>
                <td width='20%'> Product Model</td>
                <td width='20%'> Quantity (Options)</td>
            </tr></thead>";
            /*$message .= "<br>______________________________________________________________<br>";*/
            $srno = 0;
            foreach($lowProductsArray as $key => $product){
                if(isset($product['details']['name']) && !empty($product['details']['name'])){
                    $pLink = $this->url->link('catalog/product/update', '&product_id=' . $product['details']['product_id'] , 'SSL');
                    $srno++;
                    $message .= "<tr style='border: 1px solid #010101;'><td>".$srno.")</td><td><a href='".$pLink."' target='_blank'>".$product['details']['name']."</a></td><td>".$product['details']['model']." </td><td>";
                    if(isset($product['options']) && !empty($product['options'])){
                            foreach($product['options'] as $key => $option){
                                if(!$option['name'] || $option['name'] == ''){
                                   $message .= $option['quantity']. " ( ".$option['value']." )<br>"; 
                                }else{
                                    $message .= $option['quantity']. " ( ".$option['name']." - ".$option['value']." )<br>";
                                }
                            }
                            $message .=  "</td></tr>";  
                    }else{
                            $message .= $product['details']['quantity']."</td></tr>";
                    }
                }
            }
            $message .= "</table><br>View the full report of your <a href='".$adminLink."' target='_blank'>low-stock items</a> at any time in Low Stock module by <a href='//www.bytestechnolab.com'>Bytes Technolab.<br><br>Thank you,<br><div style='color:#ccc;font-size10px;'>Low Stock Alert v4.0 - powered by Bytes Technolab<br>info@bytestechnolab.com</div></div>";            
            $mail->setHtml($message);
            $this->trackLog("Message: ".$message);
            $emailArr = explode(",",$emails);
			foreach($emailArr as $email){
				$this->trackLog("sent to: ".$email);
				$mail->setTo($email);
				$mail->send();			     
			}
			            
        }
        
        public function getQuantityAlert($productId=''){
            //echo "---".$productId.'----';
            if(!$productId){
                return $this->config->get('stockalert_inventory_count')?$this->config->get('stockalert_inventory_count'):0;
            }
            $sql = "SELECT ".DB_PREFIX."product.quantityalert FROM " . DB_PREFIX . "product WHERE product_id = '" . (int)$productId. "' LIMIT 1";
            $product = $this->db->query($sql);
            
            if($product->num_rows){
                //$this->trackLog('No Products found');
                return $product->row['quantityalert'];
            }
            return $this->config->get('stockalert_inventory_count')?$this->config->get('stockalert_inventory_count'):0;
        }
        
        public function setQuantityAlert($productId,$quantityAlert){
            if(!$productId) return ;
            $sql = "UPDATE " . DB_PREFIX . "product set quantityalert = '".(int)$quantityAlert."' WHERE product_id = '" . (int)$productId. "' LIMIT 1";
            return $this->db->query($sql);
        }
}
?>