<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
	<div class="page-header">
		<div class="container-fluid">
			<div class="pull-right">
				<button type="submit" form="form-menu" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
				<a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a> </div>
			<h1><?php echo $heading_title; ?></h1>
			<ul class="breadcrumb">
				<?php foreach ($breadcrumbs as $breadcrumb) { ?>
				<li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
				<?php } ?>
			</ul>
		</div>
	</div>
	<div class="container-fluid">
		<?php if ($error_warning) { ?>
		<div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
			<button type="button" class="close" data-dismiss="alert">&times;</button>
		</div>
		<?php } ?>
		<div class="panel panel-default">
			<div class="panel-heading">
				<h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_form; ?></h3>
			</div>
			<div class="panel-body">
				<form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-menu" class="form-horizontal">
					<ul class="nav nav-tabs">
						<li class="active"><a href="#tab-general" data-toggle="tab"><?php echo $tab_general; ?></a></li>
						<li><a href="#tab-data" data-toggle="tab"><?php echo $tab_data; ?></a></li>
					</ul>
					<div class="tab-content">
						<div class="tab-pane active" id="tab-general">
							<ul class="nav nav-tabs" id="language">
								<?php foreach ($languages as $language) { ?>
								<li><a href="#language<?php echo $language['language_id']; ?>" data-toggle="tab"><img src="language/<?php echo $language['code']; ?>/<?php echo $language['code']; ?>.png" title="<?php echo $language['name']; ?>" /> <?php echo $language['name']; ?></a></li>
								<?php } ?>
							</ul>
							<div class="tab-content">
								<?php foreach ($languages as $language) { ?>
								<div class="tab-pane" id="language<?php echo $language['language_id']; ?>">
									<div class="form-group required">
										<label class="col-sm-2 control-label" for="input-name<?php echo $language['language_id']; ?>"><?php echo $entry_name; ?></label>
										<div class="col-sm-10">
											<input type="text" name="menu_description[<?php echo $language['language_id']; ?>][name]" value="<?php echo isset($menu_description[$language['language_id']]) ? $menu_description[$language['language_id']]['name'] : ''; ?>" placeholder="<?php echo $entry_name; ?>" id="input-name<?php echo $language['language_id']; ?>" class="form-control" />
											<?php if (isset($error_name[$language['language_id']])) { ?>
											<div class="text-danger"><?php echo $error_name[$language['language_id']]; ?></div>
											<?php } ?>
										</div>
									</div>
									<div class="form-group">
										<label class="col-sm-2 control-label" for="input-description<?php echo $language['language_id']; ?>"><?php echo $entry_description; ?></label>
										<div class="col-sm-10">
											<textarea name="menu_description[<?php echo $language['language_id']; ?>][description]" placeholder="<?php echo $entry_description; ?>" id="input-description<?php echo $language['language_id']; ?>" class="form-control"><?php echo isset($menu_description[$language['language_id']]) ? $menu_description[$language['language_id']]['description'] : ''; ?></textarea>
										</div>
									</div>
								</div>
								<?php } ?>
							</div>
						</div>
						<div class="tab-pane" id="tab-data">
							<div class="form-group">
								<label class="col-sm-2 control-label" for="input-parent"><?php echo $entry_parent; ?></label>
								<div class="col-sm-4">
									<input type="text" name="path" value="<?php echo $path; ?>" placeholder="<?php echo $entry_parent; ?>" id="input-parent" class="form-control" />
									<input type="hidden" name="parent_id" value="<?php echo $parent_id; ?>" />
								</div>
							</div>
							<div class="form-group">
								<label class="col-sm-2 control-label" for="input-link"><?php echo $entry_link; ?></label>
								<div class="col-sm-2">
									<select name="link" id="input-link" class="form-control">
										<option value="0" selected="selected"><?php echo $text_none; ?></option>
										<?php foreach ($current_links as $link) { ?>
										<?php if ($links == $link) { ?>
										<option value="<?php echo $link; ?>" selected="selected"><?php echo $link; ?></option>
										<?php } else { ?>
										<option value="<?php echo $link; ?>"><?php echo $link; ?></option>
										<?php } ?>
										<?php } ?>
									</select>
								</div>
								<div class="col-sm-2">
									<input type="text" name="addition" value="<?php echo $addition; ?>" class="form-control" />
								</div>
							</div>
							<div class="form-group">
								<label class="col-sm-2 control-label"><?php echo $entry_user_group; ?></label>
								<div class="col-sm-4">
									<div class="well well-sm" style="height: 100px; overflow: auto;">
										<?php foreach ($user_groups as $group) { ?>
										<div class="checkbox">
											<label>
												<?php if (in_array($group['user_group_id'], $menu_user_group)) { ?>
												<input type="checkbox" name="menu_user_group[]" value="<?php echo $group['user_group_id']; ?>" checked="checked" />
												<?php echo $group['name']; ?>
												<?php } else { ?>
												<input type="checkbox" name="menu_user_group[]" value="<?php echo $group['user_group_id']; ?>" />
												<?php echo $group['name']; ?>
												<?php } ?>
											</label>
										</div>
										<?php } ?>
									</div>
								</div>
								<div class="col-sm-6"> <span class="help-block"><?php echo $help_user_group; ?></span> </div>
							</div>
							<div class="form-group">
								<label class="col-sm-2 control-label" for="input-icon"><?php echo $entry_icon; ?></label>
								<div class="col-sm-4">
									<input type="text" name="icon" value="<?php echo $icon; ?>" placeholder="<?php echo $entry_icon; ?>" id="input-icon" class="form-control" />
								</div>
								<div class="col-sm-6"> <span class="help-block"><?php echo $help_icon; ?></span> </div>
							</div>
							<div class="form-group">
								<label class="col-sm-2 control-label" for="input-position"><?php echo $entry_position; ?></label>
								<div class="col-sm-4">
									<select name="position" id="input-position" class="form-control">
										<option value="left" <?php echo ($position == 'left' ? 'selected="selected"' : ''); ?>><?php echo $text_left; ?></option>
										<option value="top" <?php echo ($position == 'top' ? 'selected="selected"' : ''); ?>><?php echo $text_top; ?></option>
										<option value="board" <?php echo ($position == 'board' ? 'selected="selected"' : ''); ?>><?php echo $text_board; ?></option>
									</select>
								</div>
								<div class="col-sm-6"> <span class="help-block"><?php echo $help_position; ?></span> </div>
							</div>
							<div class="form-group">
								<label class="col-sm-2 control-label" for="input-sort-order"><?php echo $entry_sort_order; ?></label>
								<div class="col-sm-4">
									<input type="text" name="sort_order" value="<?php echo $sort_order; ?>" placeholder="<?php echo $entry_sort_order; ?>" id="input-sort-order" class="form-control" />
								</div>
							</div>
							<div class="form-group">
								<label class="col-sm-2 control-label" for="input-status"><?php echo $entry_status; ?></label>
								<div class="col-sm-4">
									<select name="status" id="input-status" class="form-control">
										<?php if ($status) { ?>
										<option value="1" selected="selected"><?php echo $text_enabled; ?></option>
										<option value="0"><?php echo $text_disabled; ?></option>
										<?php } else { ?>
										<option value="1"><?php echo $text_enabled; ?></option>
										<option value="0" selected="selected"><?php echo $text_disabled; ?></option>
										<?php } ?>
									</select>
								</div>
							</div>
						</div>
					</div>
				</form>
			</div>
		</div>
	</div>
</div>
<script type="text/javascript"><!--
<?php foreach ($languages as $language) { ?>
$('#input-description<?php echo $language['language_id']; ?>').summernote({
	<?php if ($lang == 'tr') { ?>
	lang: 'tr-TR',
	<?php } ?>
	height: 300,
	codemirror: { // codemirror options
		theme: 'monokai',
		lineNumbers: true,
		lineWrapping: true
	}
});
<?php } ?>
//--></script> 
<script type="text/javascript"><!--
$('input[name=\'path\']').autocomplete({
	'source': function(request, response) {
		$.ajax({
			url: 'index.php?route=setting/menu/autocomplete&token=<?php echo $token; ?>&filter_name=' +  encodeURIComponent(request),
			dataType: 'json',
			success: function(json) {
				json.unshift({
					'menu_id': 0,
					'name': '<?php echo $text_none; ?>'
				});

				response($.map(json, function(item) {
					return {
						label: item['name'],
						value: item['menu_id']
					}
				}));
			}
		});
	},
	'select': function(item) {
		$('input[name=\'path\']').val(item['label']);
		$('input[name=\'parent_id\']').val(item['value']);
	}
});
//--></script> 
<script type="text/javascript"><!--
$('#language a:first').tab('show');
//--></script> 
<?php echo $footer; ?>