<?php 
class ControllerAccountActivate extends Controller {  
	public function index() {
    $this->load->language('account/email_active');
		$this->load->model('account/activate');
  
    $this->document->setTitle($this->language->get('active_heading_title'));

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home'),       	
		); 

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_account'),
			'href'      => $this->url->link('account/account', '', 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_activate'),
			'href'      => $this->url->link('account/activate')
		);

    $data['heading_title'] = $this->language->get('active_heading_title');

		// Passkey that got from link
		$parts = explode('passkey=', (string)$this->request->server['REQUEST_URI']);
		
		if (isset($parts[1])) {
			$passkey=$parts[1];
		}
		if (isset($passkey)) {
			$result=$this->model_account_activate->getCustomerByKey($passkey);
			$count=$this->model_account_activate->getTotalCustomersByPasskey($passkey);
		} else {
			$result=false;
			$count=0;
		}
		// If successfully queried
		if($result && $count==1){
			$this->model_account_activate->updateCustomer($passkey);
			
			$data['text_message'] = $this->language->get('confirm_success_message');	
		} else { // if not found passkey, display message "Wrong Confirmation code"
			$data['text_message'] = $this->language->get('confirm_error_message');
		}
		
    	$data['button_continue'] = $this->language->get('button_continue');
		
		if ($this->cart->hasProducts()) {
			$data['continue'] = $this->url->link('checkout/cart', '', 'SSL');
		} else {
			$data['continue'] = $this->url->link('account/account', '', 'SSL');
		}
		
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['column_right'] = $this->load->controller('common/column_right');
		$data['content_top'] = $this->load->controller('common/content_top');
		$data['content_bottom'] = $this->load->controller('common/content_bottom');
		$data['footer'] = $this->load->controller('common/footer');
		$data['header'] = $this->load->controller('common/header');

		$this->response->setOutput($this->load->view('account/activate', $data));			
  }
	
	public function resend() {
		$this->load->language('account/email_active');
		$this->load->model('account/customer');
		
		$json = array();	
		
		$customer_info = $this->model_account_customer->getCustomerByEmail($this->request->post['email']);
		
		if (!$customer_info) {
			$json['error'] = sprintf($this->language->get('error_customer'), $this->request->post['email']);
		}
						
		if (!$json) {
		
			$subject = sprintf($this->language->get('text_resend_subject'), $this->config->get('config_name'));
		
			$message = sprintf($this->language->get('text_resend_welcome'), $this->config->get('config_name')) . "\n\n";
		
			$message .= $this->language->get('text_resend_active_email') . "\n";
		
			$message .= $this->url->link('account/activate', 'passkey=' . $customer_info['confirm_code']) . "\n\n";
			$message .= $this->language->get('text_services') . "\n\n";
			$message .= $this->language->get('text_thanks') . "\n";
			$message .= $this->config->get('config_name');
			
			$mail = new Mail();
			$mail->protocol = $this->config->get('config_mail_protocol');
			$mail->parameter = $this->config->get('config_mail_parameter');
			$mail->smtp_hostname = $this->config->get('config_mail_smtp_hostname');
			$mail->smtp_username = $this->config->get('config_mail_smtp_username');
			$mail->smtp_password = html_entity_decode($this->config->get('config_mail_smtp_password'), ENT_QUOTES, 'UTF-8');
			$mail->smtp_port = $this->config->get('config_mail_smtp_port');
			$mail->smtp_timeout = $this->config->get('config_mail_smtp_timeout');	
			
			$mail->setTo($this->request->post['email']);
			$mail->setFrom($this->config->get('config_email'));
			$mail->setSender($this->config->get('config_name'));
			$mail->setSubject(html_entity_decode($subject, ENT_QUOTES, 'UTF-8'));
			$mail->setText(html_entity_decode($message, ENT_QUOTES, 'UTF-8'));
			$mail->send();
		
			$json['success'] = sprintf($this->language->get('text_resend_success'), $this->request->post['email']);				
		}	
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));					
	}
}