<?php
class ModelAccountActivate extends Model {

	public function updateCustomer($passkey) {
      	$this->db->query("UPDATE " . DB_PREFIX . "customer SET approved = '1', status = '1' WHERE confirm_code = '" . $this->db->escape($passkey) . "'");
		$this->load->language('account/email_active');
		
		$subject = sprintf($this->language->get('text_subject'), $this->config->get('config_name'));
		
		$message = sprintf($this->language->get('text_welcome'), $this->config->get('config_name')) . "\n\n";
		$message .= $this->language->get('text_login') . "\n\n";
		$message .= $this->url->link('account/login', '', 'SSL') . "\n\n";
		$message .= $this->language->get('text_services') . "\n\n";
		$message .= $this->language->get('text_thanks') . "\n";
		$message .= $this->config->get('config_name');
		
		$mail = new Mail();
		$mail->protocol = $this->config->get('config_mail_protocol');
		$mail->parameter = $this->config->get('config_mail_parameter');
		$mail->smtp_hostname = $this->config->get('config_mail_smtp_hostname');
		$mail->smtp_username = $this->config->get('config_mail_smtp_username');
		$mail->smtp_password = html_entity_decode($this->config->get('config_mail_smtp_password'), ENT_QUOTES, 'UTF-8');
		$mail->smtp_port = $this->config->get('config_mail_smtp_port');
		$mail->smtp_timeout = $this->config->get('config_mail_smtp_timeout');
		
		$mail->setTo($this->getEmailByPasskey($passkey));
		$mail->setFrom($this->config->get('config_email'));
		$mail->setSender($this->config->get('config_name'));
		$mail->setSubject(html_entity_decode($subject, ENT_QUOTES, 'UTF-8'));
		$mail->setText(html_entity_decode($message, ENT_QUOTES, 'UTF-8'));
		$mail->send();
		
		if ($this->config->get('config_account_mail')) {
			$subject = sprintf($this->language->get('text_admin_subject'), $this->config->get('config_name'));
			$message=sprintf($this->language->get('text_admin_notify'), $this->getEmailByPasskey($passkey)) . "\n\n";
			$message .= $this->language->get('text_thanks') . "\n";
			$message .= $this->config->get('config_name');
			$mail->setTo($this->config->get('config_email'));
			$mail->setSubject(html_entity_decode($subject, ENT_QUOTES, 'UTF-8'));
			$mail->setText(html_entity_decode($message, ENT_QUOTES, 'UTF-8'));
			$mail->send();
			
			// Send to additional alert emails if new account email is enabled
			$emails = explode(',', $this->config->get('config_alert_emails'));
			
			foreach ($emails as $email) {
				if (strlen($email) > 0 && preg_match('/^[^\@]+@.*\.[a-z]{2,6}$/i', $email)) {
					$mail->setTo($email);
					$mail->send();
				}
			}
		}
		
		$this->db->query("UPDATE " . DB_PREFIX . "customer SET confirm_code = '' WHERE confirm_code = '" . $this->db->escape($passkey) . "'");
	}
					
	public function getCustomerByKey($passkey) {
		$query = $this->db->query("SELECT confirm_code FROM " . DB_PREFIX . "customer WHERE confirm_code = '" . $this->db->escape($passkey) . "'");
		
		return $query->row;
	}
			
	public function getTotalCustomersByPasskey($passkey) {
		$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "customer WHERE confirm_code = '" . $this->db->escape($passkey) . "'");
		
		return $query->row['total'];
	}
	public function getEmailByPasskey($passkey) {
		$query = $this->db->query("SELECT email FROM " . DB_PREFIX . "customer WHERE confirm_code = '" . $this->db->escape($passkey) . "'");
		
		return $query->row['email'];
	}
}
?>