<?php
class ModelExtensionTotalMyocPriceRounding extends Model {
	public function getTotal($total_data) {
		$title = json_decode($this->config->get('myoc_price_rounding_description'), true);

		$display = $this->config->get('myoc_price_rounding_display');

		$login_required = $this->config->get('myoc_price_rounding_login');

		$rules = json_decode($this->config->get('myoc_price_rounding_rule'), true);

		$rule_exist = false;

		$op = '';

		$display_value = 0;

		$round_value = 0;

		$currency_total = $this->currency->convert($total_data['total'], $this->config->get('config_currency'), $this->session->data['currency']);

		foreach ($rules as $rule) {
			//store
			if(isset($rule['store']) && in_array($this->config->get('config_store_id'), $rule['store']))
			{
				//login
				if(!$login_required || ($this->customer->isLogged() && isset($rule['customer_group']) && in_array($this->customer->getGroupId(), $rule['customer_group'])))
				{
					//currency
					if(isset($rule['currency']) && in_array($this->currency->getId($this->session->data['currency']), $rule['currency']))
					{
						//price range
						if($currency_total >= $rule['range_from'] && $currency_total <= $rule['range_to'] && $rule['nearest'] <= $currency_total)
						{
							$rule_exist = true;

							if($rule['rounding'] == 'fix') {
								//get fixed nearest value
								$round_value = floor($currency_total/$this->round_up($rule['nearest'])) * $this->round_up($rule['nearest']) + $rule['nearest'];

								//if direction == near
								if($rule['direction'] == 'near' && abs($round_value - $currency_total) > ($this->round_up($rule['nearest']) / 2)) {
									if(($round_value - $currency_total) > 0) {
										$rule['direction'] = 'down'; //+ve
									} else {
										$rule['direction'] = 'up'; //-ve
									}
								}
								//adjust direction
								switch ($rule['direction']) {
									case 'up':
										$round_value += ($round_value < $currency_total ? 1 * $this->round_up($rule['nearest']) : 0);
										break;
									case 'down':
										$round_value -= ($round_value > $currency_total ? 1 * $this->round_up($rule['nearest']) : 0);
										break;
									default: //nearest
										break;
								}
							} elseif ($rule['rounding'] == 'mux') {
								//adjust direction
								switch ($rule['direction']) {
									case 'up':
										$round_value = ceil($currency_total / $rule['nearest']) * $rule['nearest'];
										break;
									case 'down':
										$round_value = floor($currency_total / $rule['nearest']) * $rule['nearest'];
										break;
									default: //nearest
										$round_value = round($currency_total / $rule['nearest']) * $rule['nearest'];
										break;
								}
							}

							$round_value = round($round_value, $this->currency->getDecimalPlace($this->session->data['currency'])) - round($currency_total, $this->currency->getDecimalPlace($this->session->data['currency']));

							break;
						}
					}
				}
			}
		}

		if(!$rule_exist) {
			return;
		}

	 	//display
		if($display == 'diff') {
			$display_value = $round_value;
		} elseif ($display == 'total') {
			$display_value = $currency_total + $round_value;
		}
		$display_value = $this->currency->convert($display_value, $this->session->data['currency'], $this->config->get('config_currency'));
		$round_value = $this->currency->convert($round_value, $this->session->data['currency'], $this->config->get('config_currency'));

		if($round_value !== 0.00 || $this->config->get('myoc_price_rounding_zero')) { //display zero?
			$total_data['totals'][] = array(
				'code'       => 'myoc_price_rounding',
				'title'      => $title[$this->config->get('config_language_id')]['title'],
				'value'      => $display_value,
				'sort_order' => $this->config->get('myoc_price_rounding_sort_order')
			);
		}

		$total_data['total'] += $round_value;
	}

	private function round_up($value) {
		//return 10s multiplier of decimal places
		//e.g. .01, .1, 1, 10, 100, etc..
		$multiplier = 1;
		if($value >= 1) {
			while ($value >= 1) {
				$value /= 10;
				$multiplier *= 10;
			}
		} elseif ($value < 0.1) {
			while ($value < 0.1) {
				$value *= 10;
				$multiplier /= 10;
			}
		}
		return $multiplier;
	}
}
?>
