<?php   
/**
 * Stock Alert model class
 * 
 * Created by Bhavik Shah / Bytes Technolab
 * www.bytestechnolab.com / bhavik@bytestechnolab.com
 */
class ModelStockalertStockalert extends Model
{    
        private $eventTrigger = '';
        private $doLog = true;
        private $log = '';
       
        public function getInstance($data){
                $this->eventTrigger = $data['eventTrigger'];
                
                if($this->doLog) $this->log = new Log('stockalert-'.$this->eventTrigger.'.log');
                return $this;
        }
        public function trackLog($data){
            if($this->doLog){
                $message = print_r($data, true);
                $this->log->write($message);
            }
        }
        
        public function orderAlert($orderId){
            
            $this->trackLog('orderAlert: '.$orderId);
            $order_product_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_product WHERE order_id = '" . (int)$orderId . "'");
            $lowProductsArray = array();
            foreach ($order_product_query->rows as $order_product){
                $this->trackLog('--> Product: '.$order_product['product_id']);
                $columns = "quantity, model,sku,name,quantityalert,subtract";
                if($this->isOpenstockInstalled) $columns .= ", has_option ";
                $product_query = $this->db->query("SELECT ".DB_PREFIX."product.product_id, $columns FROM ".DB_PREFIX."product join ".DB_PREFIX."product_description on ".DB_PREFIX."product.product_id=".DB_PREFIX."product_description.product_id   WHERE ".DB_PREFIX."product.product_id = '" . (int)$order_product['product_id'] . "'");
                $alert_count = $this->config->get('stockalert_inventory_count')?$this->config->get('stockalert_inventory_count'):0;
                            
                if($this->config->get('stockalert_product_based_alert') === 'Y' && $product_query->row['quantityalert'] ){     
                    $alert_count = $product_query->row['quantityalert'];
                }
                $this->trackLog('-->Stock Compare: Stock ='.$product_query->row['quantity'].' alert= '.$alert_count);
                if ($product_query->row['subtract'] == 1 && $product_query->row['quantity'] <	$alert_count) {
                    $lowInventory_product['product_id'] = $product_query->row['product_id'];
                    $lowInventory_product['name'] = $product_query->row['name'];
                    $lowInventory_product['model'] = $product_query->row['model']; 
                    $lowInventory_product['sku'] = $product_query->row['sku']; 
                    $lowInventory_product['quantity'] = $product_query->row['quantity']; 
                    $lowProductsArray[$product_query->row['product_id']]['details'] = $lowInventory_product;
                    $this->trackLog('-->Product alert: 1');
                }
                
				{ ## this normal case simple opencart options.
                    $this->trackLog('-->Normal Alert: 1');
                    $where = " quantity <= ".(int)$alert_count." ";
                    $order_option_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_option WHERE order_id = '" . (int)$orderId . "' AND order_product_id = '" . (int)$order_product['order_product_id'] . "'");
                    if($order_option_query->num_rows != 0){
                        $this->trackLog('---->Total Options: '.$order_option_query->num_rows);
                        foreach ($order_option_query->rows as $option) {
                            $pOption_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_option_value WHERE product_option_value_id = '" . (int)$option['product_option_value_id'] . "' ");
                            $this->trackLog('---->options: rows='.$pOption_query->num_rows.' value='."SELECT * FROM " . DB_PREFIX . "product_option_value WHERE product_option_value_id = '" . (int)$option['product_option_value_id'] . "' AND quantity <= ".(int)$alert_count." ");
                            
                            if($pOption_query->num_rows){
                                /* since product_option_value_id is unique, above will always be single record.*/
                                $this->trackLog('---->options: name='.$option['name'].' value='.$option['value']);
                                $this->trackLog('---->Stock: stock='.$pOption_query->row['quantity'].' alert='.$alert_count);
                                
                                if ($pOption_query->row['quantity'] <= $alert_count) {  
                                    if(!isset($lowProductsArray[$product_query->row['product_id']]['details'])){
                                        $lowInventory_product['product_id'] = $product_query->row['product_id'];
                                        $lowInventory_product['name'] = $product_query->row['name'];
                                        $lowInventory_product['model'] = $product_query->row['model']; 
                                        $lowInventory_product['sku'] = $product_query->row['sku']; 
                                        $lowInventory_product['quantity'] = $product_query->row['quantity']; 
                                        $lowProductsArray[$product_query->row['product_id']]['details'] = $lowInventory_product;
                                    }
                                    $lowInventory_productoption = array();
                                    $lowInventory_productoption['name'] = $option['name'];
                                    $lowInventory_productoption['value'] = $option['value'];
                                    $lowInventory_productoption['quantity'] = $pOption_query->row['quantity'];
                                    $lowProductsArray[$product_query->row['product_id']]['options'][] =  $lowInventory_productoption;
                                    /*$stockLog .= "/n --------------- /n";
                                    $stockLog .= "/n".json_encode($lowInventory_product);
                                    $stockLog .= "/n --------------- /n";*/
                                }
                            }                        
                        }
                        
                    }else{
                        $this->trackLog("-->no normal option found");
                    }
                }
               $this->trackLog('End of product:');
               //$this->trackLog($lowProductsArray);
            }
            if(!empty($lowProductsArray)){
                $this->sendAlert($lowProductsArray,'New Order');
            }
        }
        
        public function sendAlert($lowProductsArray,$type){
            $this->trackLog('sending alert: '.$type);
            $this->trackLog($lowProductsArray);
            $this->load->model('setting/store');
            $this->load->language('mail/customer');
            //$mail = new Mail($this->config->get('config_mail'));
            //$mail->protocol = $this->config->get('config_mail_protocol');
            //$mail->parameter = $this->config->get('config_mail_parameter');
            //$mail->hostname = $this->config->get('config_smtp_host');
            //$mail->username = $this->config->get('config_smtp_username');
            //$mail->password = $this->config->get('config_smtp_password');
            //$mail->port = $this->config->get('config_smtp_port');
            //$mail->timeout = $this->config->get('config_smtp_timeout');
            
        $mail = new Mail();
	$mail->protocol = $this->config->get('config_mail_protocol');
	$mail->parameter = $this->config->get('config_mail_parameter');
	$mail->smtp_hostname = $this->config->get('config_mail_smtp_hostname');
	$mail->smtp_username = $this->config->get('config_mail_smtp_username');
        $mail->smtp_password = html_entity_decode($this->config->get('config_mail_smtp_password'), ENT_QUOTES, 'UTF-8');
	$mail->smtp_port = $this->config->get('config_mail_smtp_port');
	$mail->smtp_timeout = $this->config->get('config_mail_smtp_timeout');
            
           
            
            $mail->setFrom($this->config->get('config_email'));
            $emails = $this->config->get('stockalert_inventory_emails');
            $emails = str_replace(' ','',$emails);
            if(!$emails || $emails == ''){ $emails = $this->config->get('config_email');}
            //$mail->setTo($emails);
            $mail->setSender('Stock Alert');
            $mail->setSubject('Stock Alert - '.$type);
            
            $adminLink = HTTP_SERVER.'admin/index.php?route=extension/module/stockalert/lowstockproducts';
            $message = "<div style='border:solid 1px #8EAEC3;font-size15px;padding:7px;'>Hi ".$this->config->get('config_owner').", <br><br> The following items could be out of stock soon based on <strong>$type</strong> and Now would be a good time to restock your inventory, so you can continue to sell these items without interruption..<br>
                Kindly <a href='".$adminLink."' target='_blank'>view your low-stock items</a> and revise inventory.<br><br>";
            $message .= "<table colspan=5 cellpadding=5 style='border-collapse: collapse;width: 100%;border: 1px solid #010101;border-left: 1px solid #010101;margin-bottom: 20px;'>
            <thead style='display: table-header-group;vertical-align: middle;border: 1px solid #010101;background:#EE6A50;'><tr style='display: table-row;'>
                <td width='5%'> Sr.no</td>
                <td width='40%'> Product Name</td>
                <td width='20%'> Product Model</td>
                <td width='20%'> Quantity (Options)</td>
            </tr></thead>";
            /*$message .= "<br>______________________________________________________________<br>";*/
            $srno = 0;
            foreach($lowProductsArray as $key => $product){
                if(isset($product['details']['name']) && !empty($product['details']['name'])){
                    $pLink = HTTP_SERVER.'admin/index.php?route=catalog/product/edit&product_id=' . $product['details']['product_id'];
                    $srno++;
                    $message .= "<tr style='border: 1px solid #010101;'><td>".$srno.")</td><td><a href='".$pLink."' target='_blank'>".$product['details']['name']."</a></td><td>".$product['details']['model']." </td><td>";
                    if(isset($product['options']) && !empty($product['options'])){
                            foreach($product['options'] as $key => $option){
                                if(!isset($option['name']) || $option['name'] == ''){
                                   $message .= $option['quantity']. " ( ".$option['value']." )<br>"; 
                                }else{
                                    $message .= $option['quantity']. " ( ".$option['name']." - ".$option['value']." )<br>";
                                }
                            }
                            $message .=  "</td></tr>";  
                    }else{
                            $message .= $product['details']['quantity']."</td></tr>";
                    }
                }
            }
            $message .= "</table><br>View the full report of your <a href='".$adminLink."' target='_blank'>low-stock items</a> at any time in Low Stock module by <a href='//www.bytestechnolab.com'>Bytes Technolab.<br><br>Thank you,<br><div style='color:#ccc;font-size10px;'>Low Stock Alert v4.0 - powered by Bytes Technolab<br>info@bytestechnolab.com</div></div>";
            $mail->setHtml($message);
            $this->trackLog("Message: ".$message);
			$emailArr = explode(",",$emails);
			foreach($emailArr as $email){
				$this->trackLog("sent to: ".$email);
				$mail->setTo($email);
				$mail->send();			     
			}
        }
}
?>